using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Security;
using System.Security.Cryptography;

namespace CEncryptFile
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            String file_path = Application.StartupPath;
            file_path = file_path.Substring(0, file_path.LastIndexOf("\\"));
            file_path = file_path.Substring(0, file_path.LastIndexOf("\\"));
            txtPlaintext.Text = file_path + "\\text.dat";
            txtPlaintextFile.Text = file_path + "\\plaintext.txt";
            txtCiphertextFile.Text = file_path + "\\cyphertext.dat";
            txtDecipheredFile.Text = file_path + "\\decyphered.txt";

            // Display the original file.
            txtPlaintext.Text = File.ReadAllText(txtPlaintextFile.Text);
        }

        // Encrypt or decrypt a file, saving the results 
        // in another file.
        private void CryptFile(String password, String in_file, String out_file, bool encrypt)
        {
            // Create input and output file streams.
            FileStream in_stream = new FileStream(in_file, FileMode.Open, FileAccess.Read);
            FileStream out_stream = new FileStream(out_file, FileMode.Create, FileAccess.Write);

            // Make a triple DES service provider.
            TripleDESCryptoServiceProvider des_provider = new TripleDESCryptoServiceProvider();

            // Find a valid key size for this provider.
            int key_size_bits = 0;
            for (int i = 1024; i>1; i--)
            {
                if (des_provider.ValidKeySize(i))
                {
                    key_size_bits = i;
                    break;
                }
            }

            // Get the block size for this provider.
            int block_size_bits = des_provider.BlockSize;

            // Generate the key and initialization vector.
            byte[] key = null;
            byte[] iv =null;
            byte[] salt = {0x10, 0x20, 0x12, 0x23, 0x37, 0xA4, 0xC5, 0xA6, 0xF1, 0xF0, 0xEE, 0x21, 0x22, 0x45};

            MakeKeyAndIV(password, salt, key_size_bits, block_size_bits, ref key, ref iv);

            // Make the encryptor or decryptor.
            ICryptoTransform crypto_transform;
            if (encrypt)
            {
                crypto_transform = des_provider.CreateEncryptor(key, iv);
            } else {
                crypto_transform = des_provider.CreateDecryptor(key, iv);
            }

            // Attach a crypto stream to the output stream.
            CryptoStream crypto_stream = new CryptoStream(
                out_stream, crypto_transform, CryptoStreamMode.Write);

            // Encrypt or decrypt the file.
            const int BLOCK_SIZE = 1024;
            byte[] buffer = new byte[BLOCK_SIZE];
            int bytes_read;
            for (;;)
            {
                // Read some bytes.
                bytes_read = in_stream.Read(buffer, 0, BLOCK_SIZE);
                if (bytes_read == 0) break;

                // Write the bytes into the CryptoStream.
                crypto_stream.Write(buffer, 0, bytes_read);
            }

            // Close the streams.
            try
            {
                crypto_stream.Close();
            }
            catch (CryptographicException)
            {
                // Ignore this one. The password is bad.
            }
            catch (Exception ex)
            {
                // Re-raise this one.
                throw ex;
            }

            in_stream.Close();
            out_stream.Close();
        }

        // Use the password to generate key bytes.
        private void MakeKeyAndIV(String password, byte[] salt, int key_size_bits, int block_size_bits, ref byte[] key, ref byte[] iv)
        {
            Rfc2898DeriveBytes derive_bytes = new Rfc2898DeriveBytes(
                password, salt, 1000);

            key = derive_bytes.GetBytes(key_size_bits / 8);
            iv = derive_bytes.GetBytes(block_size_bits / 8);
        }

        // Encrypt the plaintext file.
        private void btnEncrypt_Click(object sender, EventArgs e)
        {
            // Encrypt the file.
            CryptFile(txtPassword.Text, txtPlaintextFile.Text, txtCiphertextFile.Text, true);

            // Display the result.
            txtCiphertext.Text = File.ReadAllText(txtCiphertextFile.Text);
        }

        // Decrypt the cyphertext file.
        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            // Encrypt the file.
            CryptFile(txtPassword.Text, txtCiphertextFile.Text, txtDecipheredFile.Text, false);

            // Display the result.
            txtDeciphered.Text = File.ReadAllText(txtDecipheredFile.Text);
        }
    }
}