using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Security.Cryptography;

namespace CHashFile
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            String file_path = Application.StartupPath;
            file_path = file_path.Substring(0, file_path.LastIndexOf("\\"));
            file_path = file_path.Substring(0, file_path.LastIndexOf("\\"));
            txtDataFile.Text = file_path + "\\TestData.txt";
            txtHashFile.Text = file_path + "\\TestData.hsh";
            txtDataFile.Select(0, 0);
            txtHashFile.Select(0, 0);
        }

        // Display the file's hash value.
        private void btnHash_Click(object sender, EventArgs e)
        {
            // Open the file.
            FileStream file_stream = new FileStream(txtDataFile.Text, FileMode.Open);

            // Use an SHA1Managed object to hash the bytes.
            SHA1Managed sha1 = new SHA1Managed();
            byte[] hash_bytes = sha1.ComputeHash(file_stream);

            // Display the hash value.
            String txt = "";
            foreach (byte b in hash_bytes)
            {
                txt += b.ToString("X").PadLeft(2, '0');
            }
            txtHashValue.Text = txt;

            // Clean up.
            file_stream.Close();
            file_stream.Dispose();

            // Display the old hash value.
            if (File.Exists(txtHashFile.Text))
            {
                txtOldHashValue.Text = File.ReadAllText(txtHashFile.Text);
            } else {
                txtOldHashValue.Text = "<none>";
            }
            if (txtHashValue.Text == txtOldHashValue.Text)
            {
                txtOldHashValue.BackColor = Color.White;
            } else {
                txtOldHashValue.BackColor = Color.Yellow;
            }
        }

        // Save the hash value into the hash file.
        private void btnSave_Click(object sender, EventArgs e)
        {
            File.WriteAllText(txtHashFile.Text, txtHashValue.Text);
        }
    }
}