using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Reflection;
using System.Diagnostics;

namespace CReflectionDumpClassInfo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // List our classes.
        private void Form1_Load(object sender, EventArgs e)
        {
            Assembly assem = Assembly.GetExecutingAssembly();

            lstClasses.Items.Clear();

            foreach (Type target_type in assem.GetTypes())
            {
                lstClasses.Items.Add(target_type);
            }
        }

        private void lstClasses_SelectedIndexChanged(object sender, EventArgs e)
        {
            Debug.WriteLine("****************************************");
            Type target_type = (Type)lstClasses.SelectedItem;
            if (target_type == null) return;

            Debug.WriteLine("\n*** Constructors ***");
            foreach (ConstructorInfo ci in target_type.GetConstructors())
                Debug.WriteLine(ci.Name);

            Debug.WriteLine("\n*** Methods ***");
            foreach (MethodInfo mi in target_type.GetMethods())
                Debug.WriteLine(mi.Name);

            Debug.WriteLine("\n*** Properties ***");
            foreach (PropertyInfo pi in target_type.GetProperties())
                Debug.WriteLine(pi.Name);

            Debug.WriteLine("\n*** Fields ***");
            foreach (FieldInfo fi in target_type.GetFields())
                Debug.WriteLine(fi.Name);

            Debug.WriteLine("\n*** Events ***");
            foreach (EventInfo ei in target_type.GetEvents())
                Debug.WriteLine(ei.Name);

            Debug.WriteLine("\n*** Interfaces ***");
            foreach (Type itype in target_type.GetInterfaces())
                Debug.WriteLine(itype.Name);

            Debug.WriteLine("****************************************");
        }
    }
}