using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Reflection;

namespace CReflectionFormProperties
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Make column headers.
            lvwProperties.View = View.Details;
            lvwProperties.Columns.Clear();
            lvwProperties.Columns.Add("Property", 10, HorizontalAlignment.Left);
            lvwProperties.Columns.Add("Type", 10, HorizontalAlignment.Left);
            lvwProperties.Columns.Add("Value", 10, HorizontalAlignment.Left);

            // List the properties.
            // (Use the class you want to study instead of Form1.)
            lvwProperties.Items.Clear();
            foreach (PropertyInfo pi in this.GetType().GetProperties())
            {
                if (pi.GetIndexParameters().Length == 0)
                {
                    Object property_value = pi.GetValue(this, null);
                    if (property_value == null)
                    {
                        ListViewMakeRow(lvwProperties,
                            pi.Name,
                            new String[] { pi.PropertyType.ToString(), "<null>" });
                    } else {
                        ListViewMakeRow(lvwProperties,
                            pi.Name,
                            new String[] { pi.PropertyType.ToString(), property_value.ToString() });
                    }
                } else {
                    ListViewMakeRow(lvwProperties,
                        pi.Name,
                        new String[] { pi.PropertyType.ToString(), "<array>" });
                }
            }

            // Size the columns to fit the data.
            foreach (ColumnHeader col in lvwProperties.Columns)
                col.Width = -2;
        }

        // Helper subroutine ListViewMakeRow makes an item and sub-items in a ListView control.
        // Make a ListView row.
        private void ListViewMakeRow(ListView lvw, String item_title, String [] subitem_titles)
        {
            // Make the item.
            ListViewItem new_item = lvw.Items.Add(item_title);

            // Make the sub-items.
            for (int i = subitem_titles.GetLowerBound(0); i <= subitem_titles.GetUpperBound(0); i++)
                new_item.SubItems.Add(subitem_titles[i]);
        }
    }
}