using System;
using System.Collections.Generic;
using System.Text;

using System.Windows.Forms;

namespace CReflectionDumpClassInfo
{
    class Person : IComparable<Person>
    {
        // Properties.
        private String m_FirstName = "<no first name>";
        public String FirstName
        {
            get { return m_FirstName; }
            set { m_FirstName = value; }
        }

        public String LastName = "<no last name>";

        // Constructors.
        public Person()
        {
        }
        public Person(String new_FirstName, String new_LastName)
        {
            FirstName = new_FirstName;
            LastName = new_LastName;
        }

        // Public methods.
        public override String ToString()
        {
            return m_FirstName + " " + LastName;
        }

        public void PublicSub()
        {
        }

        protected void ProtectedSub()
        {
        }

        internal void InternalSub()
        {
        }

        protected internal void ProtectedInternalSub()
        {
        }

        private void PrivateSub()
        {
        }

        public void Echo(String txt)
        {
            MessageBox.Show("Echo: " + txt, "Echo", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        // Make and return a new person.
        public static Person NewPerson(String first_name, String last_name)
        {
            return new Person(first_name, last_name);
        }

        // Public events.
        public delegate void FirstNameChangedEventHandler();
        public static event FirstNameChangedEventHandler FirstNameChanged;

        public delegate void LastNameChangedEventHandler(String new_name);
        public event LastNameChangedEventHandler LastNameChanged;

        // Compare us alphabetically to another person.
        //#region IComparable<Girl> Members

        public int CompareTo(Person other)
        {
            return String.Compare(this.ToString(), other.ToString());
        }

        // #endregion
    }
}
