Imports System.Reflection

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make column headers.
        lvwProperties.View = View.Details
        lvwProperties.Columns.Clear()
        lvwProperties.Columns.Add("Property", 10, _
            HorizontalAlignment.Left)
        lvwProperties.Columns.Add("Type", 10, _
            HorizontalAlignment.Left)
        lvwProperties.Columns.Add("Value", 10, _
            HorizontalAlignment.Left)

        ' List the properties.
        ' (Use the class you want to study instead of Form1.)
        lvwProperties.Items.Clear()
        For Each pi As PropertyInfo In Me.GetType.GetProperties()
            If pi.GetIndexParameters().Length = 0 Then
                Dim property_value As Object = pi.GetValue(Me, Nothing)
                If property_value Is Nothing Then
                    ListViewMakeRow(lvwProperties, _
                        pi.Name, _
                        pi.PropertyType.ToString, _
                        "<Nothing>")
                Else
                    ListViewMakeRow(lvwProperties, _
                        pi.Name, _
                        pi.PropertyType.ToString, _
                        property_value.ToString)
                End If
            Else
                ListViewMakeRow(lvwProperties, _
                    pi.Name, _
                    pi.PropertyType.ToString, _
                    "<array>")
            End If
        Next pi

        ' Size the columns to fit the data.
        For Each col As ColumnHeader In lvwProperties.Columns
            col.Width = -2
        Next col
    End Sub

    ' Helper subroutine ListViewMakeRow makes an item and sub-items in a ListView control.
    ' Make a ListView row.
    Private Sub ListViewMakeRow(ByVal lvw As ListView, ByVal item_title As String, ByVal ParamArray subitem_titles() As String)
        ' Make the item.
        Dim new_item As ListViewItem = lvw.Items.Add(item_title)

        ' Make the sub-items.
        For i As Integer = subitem_titles.GetLowerBound(0) To _
            subitem_titles.GetUpperBound(0)
            new_item.SubItems.Add(subitem_titles(i))
        Next i
    End Sub
End Class
