Imports System.IO
Imports System.Reflection
Imports System.Resources

Public Class Form1
    Private m_TargetAssembly As Assembly

    ' Look for the ReflectionTarget program.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim dir_info As New DirectoryInfo(Application.StartupPath)
        dir_info = dir_info.Parent.Parent.Parent
        txtFile.Text = dir_info.FullName & "\ReflectionTarget\bin\Debug\ReflectionTarget.exe"
    End Sub

    ' List the target assembly's resources.
    Private Sub btnList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnList.Click
        ' Get the target assembly.
        Try
            m_TargetAssembly = Assembly.LoadFile(txtFile.Text)
        Catch ex As FileNotFoundException
            MessageBox.Show("File not found. Make sure you have built the ReflectionTarget.exe project", _
                "File Not Found", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        Catch ex As Exception
            Throw ex
        End Try

        ' List the target's manifest resource names.
        lstResourceFiles.Items.Clear()
        For Each str As String In m_TargetAssembly.GetManifestResourceNames()
            lstResourceFiles.Items.Add(str)
        Next str
    End Sub

    ' List this file's resources.
    Private Sub lstResourceFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstResourceFiles.SelectedIndexChanged
        If lstResourceFiles.SelectedIndex < 0 Then Exit Sub

        lstResources.Items.Clear()

        Dim resource_reader As New ResourceReader( _
            m_TargetAssembly.GetManifestResourceStream(lstResourceFiles.Text))

        For Each dict_entry As DictionaryEntry In resource_reader
            lstResources.Items.Add(New NamedObject( _
                dict_entry.Key, _
                dict_entry.Value))
        Next dict_entry

        resource_reader.Close()
    End Sub

    ' Display the selected resource.
    Private Sub lstResources_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstResources.SelectedIndexChanged
        lblString.Text = ""
        picImage.Image = Nothing
        Me.Cursor = Cursors.WaitCursor
        Refresh()

        Dim resource_info As NamedObject = _
            DirectCast(lstResources.SelectedItem, NamedObject)
        Select Case resource_info.Value.GetType.Name
            Case "Bitmap"
                picImage.Image = CType(resource_info.Value, Bitmap)
            Case "String"
                lblString.Text = CType(resource_info.Value, String)
            Case Else
                ' Try to play it as audio.
                Try
                    Dim mem_stream As UnmanagedMemoryStream = DirectCast(resource_info.Value, UnmanagedMemoryStream)
                    My.Computer.Audio.Play(mem_stream, AudioPlayMode.WaitToComplete)
                    mem_stream.Seek(0, SeekOrigin.Begin)
                Catch ex As Exception
                    MessageBox.Show(resource_info.Name & " has an unkown resource type", "Unkown Resource Type", MessageBoxButtons.OK)
                End Try
        End Select

        Me.Cursor = Cursors.Default
    End Sub

    Private Class NamedObject
        Public Name As Object
        Public Value As Object
        Public Sub New(ByVal new_key As Object, ByVal new_value As Object)
            Name = new_key
            Value = new_value
        End Sub
        Public Overrides Function ToString() As String
            Return Name.ToString & " (" & Value.GetType.ToString & ")"
        End Function
    End Class
End Class
