Public Class Person
    Implements IComparable(Of Person)

    ' Properties.
    Private m_FirstName As String = "<no first name>"
    Public Property FirstName() As String
        Get
            Return m_FirstName
        End Get
        Set(ByVal value As String)
            m_FirstName = value
        End Set
    End Property

    Public LastName As String = "<no last name>"

    Private m_BirthDate As Date
    Private Property BirthDate() As Date
        Get
            Return m_BirthDate
        End Get
        Set(ByVal value As Date)
            m_BirthDate = value
        End Set
    End Property

    ' Constructors.
    Public Sub New()

    End Sub
    Public Sub New(ByVal first_name As String, ByVal last_name As String)
        FirstName = first_name
        LastName = last_name
    End Sub

    ' Public methods.
    Public Overrides Function ToString() As String
        Return m_FirstName & " " & LastName
    End Function

    Public Sub PublicSub()
    End Sub
    Protected Sub ProtectedSub()
    End Sub
    Friend Sub FriendSub()
    End Sub
    Protected Friend Sub ProtectedFriendSub()
    End Sub
    Private Sub PrivateSub()
    End Sub
    Public Sub Echo(ByVal txt As String)
        MessageBox.Show("Echo: " & txt, "Echo", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    ' Make and return a new person.
    Public Shared Function NewPerson(ByVal first_name As String, ByVal last_name As String)
        Return New Person(first_name, last_name)
    End Function

    ' Public events.
    Public Event FirstNameChanged()
    Public Event LastNameChanged(ByVal new_name As String)

    ' Compare us alphabetically to another person.
    Public Function CompareTo(ByVal other As Person) As Integer Implements System.IComparable(Of Person).CompareTo
        Return String.Compare(Me.ToString(), other.ToString)
    End Function
End Class